from biogeme import *
def normalpdf(x,mu=0.0,s=1.0):
    d = -(x-mu)*(x-mu)
    n = 2.0*s*s
    a = d/n
    num = exp(a)
    den = s*2.506628275
    p = num / den
    return p

def lognormalpdf(x,mu,s):
    d = -(x-mu)*(x-mu)
    n = 2.0*s*s
    a = d/n
    lnum = a
    lden = log(s) + 0.918938533
    p = lnum + lden
    return p

def uniformpdf(x,a=-1,b=1.0):
    result = (x < a) * 0.0 + (x >= b) * 0.0 + (x >= a) * (x < b) / (b-a)
    return result

def triangularpdf(x,a=-1.0,b=1.0,c=0.0):
    result = (x < a) * 0.0 + (x >= b) * 0.0 + (x >= a) * (x < c) * 2.0 * ((x-a)/((b-a)*(c-a))) *  (x >= c) * (x < b)  * 2.0 * (b-x) / ((b-a)*(b-c))
    return result

def logisticcdf(x,mu=0.0,s=1.0):
    result = 1.0 /( 1.0 + exp(-(x-mu)/s))
    return result
